/************************************************************************************/
/*	Copyright 2014 Cosmic Warpigs													*/
/*																					*/
/*	This file is part of Chipotle Warfare.											*/
/*																					*/
/*   Chipotle Warfare is free software: you can redistribute it and/or modify		*/
/*    it under the terms of the GNU General Public License as published by			*/
/*    the Free Software Foundation, either version 3 of the License, or				*/
/*		(at your option) any later version.											*/
/*																					*/
/*    Chipotle Warfare is distributed in the hope that it will be useful,			*/
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of				*/
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the					*/
/*    GNU General Public License for more details.									*/
/*																					*/
/*    You should have received a copy of the GNU General Public License				*/
/*    along with Chipotle Warfare.  If not, see <http://www.gnu.org/licenses/>.		*/
/*																					*/
/************************************************************************************/

#include <stdio.h>
#include "graphsData.h"

#define GRAPHSIZE 23  
#define INFINITY 9999

#define N_NODES_LVL1 23


struct Node
{
	unsigned char x;
	unsigned char y;

};

struct Node Lvl1Nodes[N_NODES_LVL1+1]; 

char e; 
char e1; 	// Num edges lvl 1 
char n = 0; 
char dist[GRAPHSIZE][GRAPHSIZE]; 
char d[GRAPHSIZE]; 
char prev[GRAPHSIZE];
char visited[GRAPHSIZE];

char pathEnemy1[GRAPHSIZE];
char contCercano;
char distance;
char closestNode;
char Nnodes;
char dAux;
char iLoad, jLoad, wLoad, uLoad, vLoad;
char indice;
char iGetPath;
char iDij, kDij, mini;
char visited[GRAPHSIZE];

// Load the graph data for earch lvl
void LoadGraph(char lvl)
{
	// Ini dist
	for (iLoad = 0; iLoad < e; ++iLoad)
			for (jLoad = 0; jLoad < e; ++jLoad)
				dist[iLoad][jLoad] = 0;  	
	switch(lvl)
	{
		// Load from dataMaps each graph
		case 1:
		{
			e1 = 59;
			e = e1;
			n = -1;			
			for (iLoad = 0; iLoad < e; ++iLoad) 
			{
				char aux = -2;
				uLoad = graphInfo1[iLoad][0]; 
				vLoad = graphInfo1[iLoad][1];
				wLoad = graphInfo1[iLoad][2];				
				dist[uLoad][vLoad] = wLoad;
				
				// GET MAX
				if(n > vLoad)
					aux = n;
				else
					aux = vLoad;				
				if(aux < uLoad)
					n = uLoad;
				
			}
			// Ini each node to its x and y position
			Lvl1Nodes[1].x = 3; Lvl1Nodes[1].y = 4;
			Lvl1Nodes[2].x = 7; Lvl1Nodes[2].y = 4;
			Lvl1Nodes[3].x = 7; Lvl1Nodes[3].y = 8;
			Lvl1Nodes[4].x = 7; Lvl1Nodes[4].y = 11;
			Lvl1Nodes[5].x = 5; Lvl1Nodes[5].y = 11;
			Lvl1Nodes[6].x = 3; Lvl1Nodes[6].y = 11;
			Lvl1Nodes[7].x = 11; Lvl1Nodes[7].y = 8;
			Lvl1Nodes[8].x = 11; Lvl1Nodes[8].y = 1;
			Lvl1Nodes[9].x = 14; Lvl1Nodes[9].y = 8;
			Lvl1Nodes[10].x = 14; Lvl1Nodes[10].y = 11;
			Lvl1Nodes[11].x = 16; Lvl1Nodes[11].y = 11;
			Lvl1Nodes[12].x = 16; Lvl1Nodes[12].y = 6;
			Lvl1Nodes[13].x = 18; Lvl1Nodes[13].y = 6;
			Lvl1Nodes[14].x = 18; Lvl1Nodes[14].y = 11;
			Lvl1Nodes[15].x = 18; Lvl1Nodes[15].y = 16;
			Lvl1Nodes[16].x = 16; Lvl1Nodes[16].y = 16;
			Lvl1Nodes[17].x = 5; Lvl1Nodes[17].y = 15;
			Lvl1Nodes[18].x = 14; Lvl1Nodes[18].y = 15;
			Lvl1Nodes[19].x = 14; Lvl1Nodes[19].y = 18;
			Lvl1Nodes[20].x = 11; Lvl1Nodes[20].y = 11;
			Lvl1Nodes[21].x = 5; Lvl1Nodes[21].y = 18;
			Lvl1Nodes[22].x = 16; Lvl1Nodes[22].y = 1;
			
			
			
		}
		break;
	}
	
}

/* Build the path using recursivity */
void CollectPath(char dest, char enemy)
{
		
	if (prev[dest] != -1)
		CollectPath(prev[dest], enemy); // ->Recursividad
	

		pathEnemy1[indice] = dest;
	
	
	indice = indice+1;
}

void Dijkstra(char s) 
{
	//char str[50];
	iDij = 0;
	kDij = 0; 
	mini = 0;
	
	
	for (iDij = 1; iDij <= n; ++iDij) 
	{
		d[iDij] = INFINITY;
		prev[iDij] = -1; /* no path has yet been found to iDij */
		visited[iDij] = 0; /* the iDij-th element has not yet been visited */
	}
	d[s] = 0;
	
	
	for (kDij = 1; kDij <= n; ++kDij)
	{
		
		mini = -1;
		
		for (iDij = 1; iDij <= n; ++iDij)
			if (visited[iDij] == 0 && ((mini == -1) || (d[iDij] < d[mini])))			
				mini = iDij;				
			
		
		visited[mini] = 1;
		
		for (iDij = 1; iDij <= n; ++iDij)
		{
			if (dist[mini][iDij]!=0)
			{
				if (d[mini] + dist[mini][iDij] < d[iDij]) 
				{
					d[iDij] = d[mini] + dist[mini][iDij];
					prev[iDij] = mini;					
				}
			}
		}
				
		
	}
	
}

void GetPath(char src, char target, char enemy)
{
	//char str[80];
	indice = 0;
	iGetPath = 0;
	
	
	
	
	// 1. Call dijkstra
	Dijkstra(src);
	
	// Ini path
	for(iGetPath =0; iGetPath < n; iGetPath++)
	{
		if(enemy == 1)
			pathEnemy1[iGetPath] = -1;
			
			// IGUAL PARA EL RESTO
	}
	
	// 2. Get the path	
	for (iGetPath = 1; iGetPath <= n; ++iGetPath)
	{
		if(iGetPath == target)
		{
			CollectPath(iGetPath, enemy);
			break;			
		}
	}
}

// calc absolute value
char absCosmic(char val)
{
	if(val < 0)
		val = val *-1;
	return val;
} 

// Calc the absolute distance with Manhatan euristic method
char DistanceOf(char x1, char y1, char x2, char y2)
{
	
	char dx, dy;
	
		
	dx = absCosmic(x1 - x2);
	dy = absCosmic(y1 - y2);
	
	return (dx + dy);
}

// Get the Closest Node for a specific level from a coordinate
char GetClosestNode(char lvl, char src_x, char src_y)
{
	//char str[80];
	contCercano = 0;
	dAux = 0;
	distance= 9999;	
	closestNode = -1;
	
	
	
	
	// for each lvl set the collection and limit
	switch(lvl)
	{
		case 1: 
			Nnodes = N_NODES_LVL1;			
			for(contCercano=1; contCercano < Nnodes; contCercano++)
			{
				dAux = DistanceOf(src_x, src_y,  Lvl1Nodes[contCercano].x, Lvl1Nodes[contCercano].y);				
				if( distance > dAux)
				{
					distance = dAux;
					closestNode = contCercano;
				}
			}
			
			break;	
	}
	
	
	
	return closestNode;
}
