/************************************************************************************/
/*	Copyright 2014 Cosmic Warpigs													*/
/*																					*/
/*	This file is part of Chipotle Warfare.											*/
/*																					*/
/*   Chipotle Warfare is free software: you can redistribute it and/or modify		*/
/*    it under the terms of the GNU General Public License as published by			*/
/*    the Free Software Foundation, either version 3 of the License, or				*/
/*		(at your option) any later version.											*/
/*																					*/
/*    Chipotle Warfare is distributed in the hope that it will be useful,			*/
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of				*/
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the					*/
/*    GNU General Public License for more details.									*/
/*																					*/
/*    You should have received a copy of the GNU General Public License				*/
/*    along with Chipotle Warfare.  If not, see <http://www.gnu.org/licenses/>.		*/
/*																					*/
/************************************************************************************/

// Variables para la musica del menu
extern const int SONG_TABLE_MENU[];
extern const int RULE_TABLE_MENU[];
extern const int SOUND_TABLE_MENU[];

extern const int SONG_TABLE_JUEGO[];
extern const int RULE_TABLE_JUEGO[];
extern const int SOUND_TABLE_JUEGO[];

#define SOUND_SHOOT 0
#define SOUND_DEATH 1
#define SOUND_SHOOT_END 2

//Variable para los efectos de sonido (sfx)
extern const int EFFECT_TABLE[];


void music(void){
__asm	

	_SONG_TABLE_MENU:
	.dw _SONG_0

	_RULE_TABLE_MENU :
	.dw PAUTA_0
	PAUTA_0 : .DB	#8, #0, #7, #0, #6, #0, #5, #0, #129


		  _SOUND_TABLE_MENU:
	.dw SONIDO1
	.dw SONIDO2
	.dw SONIDO3
	SONIDO0 : .DB	#23, #63, #0, #116, #255, #255, #255
	SONIDO1:.DB	#162, #47, #0, #23, #93, #255, #255
	SONIDO2:.DB	#0, #10, #255, #255
	SONIDO3:.DB	#186, #58, #0, #0, #102, #0, #162, #131, #255, #255

	_SONG_TABLE_JUEGO:
	.dw _SONG_1
	//EFECTOS DE SONIDO 
	
	_EFFECT_TABLE:
		.dw _EFECTO0 // Disparar
		.dw _EFECTO1 // Morir enemigo / jugador
		.dw _EFECTO2 // Golpear enemigo / puerta
		.dw _EFECTO3 // Romper puerta
//		.dw _EFECTO4 //Coger llave



	//Disparar
	_EFECTO0:
	.db #0xB0,#0x17
	.db #0xB0,#0x18
	.db #0xB0,#0x18
	.db #0xB0,#0x1A
	.db #0x90,#0x1A
	.db #0x90,#0x1B
	.db #0x90,#0x1B
	.db #0x90,#0x1C
	.db #0xB0,#0x1C
	.db #0xB0,#0x1B
	.db #0xB0,#0x1B
	.db #0xB0,#0x1B
	.db #0x90,#0x1A
	.db #0x90,#0x1A
	.db #0x90,#0x1A
	.db #0x90,#0x19
	.db #0xB0,#0x19
	.db #0xB0,#0x18
	.db #0xB0,#0x18
	.db #0xB0,#0x18
	.db #0x90,#0x18
	.db #0x90,#0x17
	.db #0x90,#0x17
	.db #0x90,#0x16
	.db #0xB0,#0x16
	.db #0xB0,#0x17
	.db #0xB0,#0x17
	.db #0xB0,#0x16
	.db #0xFF

	//Morir enemigo / jugador
	_EFECTO1:
	.db #0xB0,#0x07
	.db #0xA0,#0x08
	.db #0xB0,#0x08
	.db #0x98,#0x0A
	.db #0x90,#0x0A
	.db #0x80,#0x0B
	.db #0x90,#0x0B
	.db #0x88,#0x0C
	.db #0x80,#0x0C
	.db #0x70,#0x0B
	.db #0x80,#0x0B
	.db #0x70,#0x0B
	.db #0x78,#0x0A
	.db #0x60,#0x0A
	.db #0x70,#0x0A
	.db #0x60,#0x09
	.db #0x60,#0x09
	.db #0x50,#0x08
	.db #0x60,#0x08
	.db #0x40,#0x08
	.db #0x60,#0x08
	.db #0x70,#0x07
	.db #0x40,#0x07
	.db #0x70,#0x06
	.db #0x30,#0x06
	.db #0x70,#0x05
	.db #0x30,#0x05
	.db #0x40,#0x04
	.db #0xFF

	//golpear enemigo / puerta
	_EFECTO2:
	.db #0x25,#0x1C
	.db #0x30,#0x2E
	.db #0x00,#0x00
	.db #0xA8,#0x0A
	.db #0xC5,#0x1A
	.db #0x00,#0x00
	.db #0x37,#0x1C
	.db #0xC5,#0x1C
	.db #0x00,#0x00
	.db #0x25,#0x18
	.db #0x30,#0x26
	.db #0xFF

	//romper puerta
	_EFECTO3:
	.db	#0x60,#0x0f
	.db	#0x40,#0x0c
	.db	#0x20,#0x08
	.db	#0x10,#0x0f
	.db	#0x60,#0x0f
	.db	#0x40,#0x0c
	.db	#0x20,#0x08
	.db	#0x10,#0x0f
	.db	#0x60,#0x0f
	.db	#0x50,#0x0c
	.db	#0x10,#0x0a
	.db	#0x10,#0x08
	.db	#0x10,#0x06
	.db	#0x10,#0x04
	.db	#0x10,#0x02
	.db	#0x60,#0x00
	.db	#0xff
	

/*	
	//coger llave
	_EFECTO4:
	.db	#0x40,#0x0C
	.db	#0x30,#0x0D
	.db	#0x35,#0x0C
	.db	#0x10,#0x0A
	.db	#0x0A,#0x0A
	.db	#0x00,#0x00
	.db	#0x0A,#0x08
	.db	#0x40,#0x09
	.db	#0x30,#0x0A
	.db	#0x35,#0x08
	.db	#0x10,#0x07
	.db	#0x0A,#0x06
	.db	#0xFF
*/

	
		
	
	
__endasm;
}


const unsigned char SONG_0[] = {
	0x05, 0x07, 0x00, 0x00, 0x3f, 0x00, 0x9b, 0x4f,
	0x51, 0x8f, 0x8e, 0x94, 0x4f, 0x4e, 0xd4, 0xfe,
	0x4f, 0x51, 0xd7, 0xfe, 0x53, 0x54, 0xd6, 0x01,
	0x4e, 0x4f, 0x91, 0x65, 0x54, 0x96, 0x65, 0x9d,
	0x62, 0x62, 0x9d, 0xbe, 0x51, 0x4f, 0x9b, 0x65,
	0x54, 0x4f, 0x51, 0x60, 0x5d, 0x5b, 0x60, 0x60,
	0x65, 0x51, 0x55, 0x60, 0x5d, 0x5b, 0x60, 0x60,
	0x65, 0x51, 0x55, 0x60, 0x65, 0x51, 0x55, 0x60,
	0x65, 0x51, 0x55, 0x51, 0x4f, 0x9b, 0x65, 0x54,
	0x4f, 0x51, 0x60, 0x5d, 0x5b, 0x60, 0x60, 0x65,
	0x51, 0x55, 0x4e, 0x4f, 0x91, 0x65, 0x54, 0x96,
	0x65, 0x9d, 0x62, 0x62, 0x9d, 0xbe, 0x60, 0x5d,
	0x5b, 0x60, 0x60, 0x65, 0x51, 0x55, 0x60, 0x65,
	0x51, 0x55, 0x60, 0x65, 0x51, 0x55, 0x4e, 0x4f,
	0x91, 0x65, 0x54, 0x96, 0x65, 0x9d, 0x62, 0x62,
	0x9d, 0xbe, 0x60, 0x5d, 0x5b, 0x60, 0x60, 0x65,
	0x51, 0x55, 0x60, 0x65, 0x51, 0x55, 0x60, 0x65,
	0x51, 0x55, 0x00, 0xc1, 0x00, 0xc1, 0x00, 0xc1,
	0x00, 0x00
};

const unsigned char SONG_1[] = {
	0x04, 0x07, 0x00, 0x00, 0x3f, 0x00, 0x4e, 0x51,
	0x4e, 0x51, 0x4e, 0x4f, 0x4e, 0x4f, 0x4e, 0x51,
	0x4e, 0x51, 0x4e, 0x4f, 0x4e, 0x4f, 0x4e, 0x51,
	0x4e, 0x51, 0x4e, 0x4f, 0x4e, 0x4f, 0x0e, 0x0e,
	0x51, 0x0f, 0x0f, 0x54, 0x11, 0x14, 0x56, 0x14,
	0x16, 0x58, 0x0e, 0x14, 0x4f, 0x11, 0x4f, 0x7e,
	0x0e, 0x14, 0x4f, 0x10, 0x11, 0x54, 0x0e, 0x0e,
	0x51, 0x0f, 0x0f, 0x54, 0x11, 0x14, 0x56, 0x14,
	0x16, 0x58, 0x8e, 0x91, 0x8e, 0x91, 0x94, 0x96,
	0x94, 0x96, 0x0e, 0x0e, 0x51, 0x0f, 0x0f, 0x54,
	0x11, 0x14, 0x56, 0x14, 0x16, 0x58, 0x00, 0xc1,
	0x00, 0xc1, 0x00, 0xc1, 0x00, 0x00
};